## gprbuild 2015

=== examples/ada_f77/Makefile ===
all: default.cgpr
	gprbuild ft.gpr

default.cgpr:
	gprconfig --batch --config Ada,,sjlj  --config Fortran -o $@

clean:
	gprclean -q -r ft.gpr
	$(RM) default.cgpr

run: all
	./fobj/ess

=== examples/libraries/Makefile ===
all: default.cgpr
	gprbuild main0.gpr
	gprbuild main1.gpr
	gprbuild main2.gpr
	gprbuild main3.gpr
	gprbuild main4.gpr

default.cgpr:
	gprconfig --batch --config Ada  --config C -o $@

clean: force
	gprclean -r main0.gpr
	gprclean -r main1.gpr
	gprclean -r main2.gpr
	gprclean -r main3.gpr
	gprclean -r main4.gpr
	$(RM) default.cgpr

run: all
	./main0
	./main1
	(PATH="lib2:${PATH}" ./main2)
	(PATH="lib3:${PATH}" ./main3)
	(PATH="lib2:${PATH}" ./main4)

force:

=== debian/changelog ===
gprbuild (2015-6) unstable; urgency=medium

  * add-targets-for-gnat-s_osconf.diff lets gprbuild ignore the new vendor
    part in architectures as listed by GCC. Closes: #838483.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 Jan 2017 18:54:51 +0100

gprbuild (2015-5) unstable; urgency=medium

  * Declare that tests/*project-with-dash-s requires libgnatvsn*-dev.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 14 May 2016 16:35:10 +0200

gprbuild (2015-4) unstable; urgency=medium

  * tests/control: two tests Depend: gnat.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 27 Apr 2016 20:57:20 +0200

gprbuild (2015-3) unstable; urgency=medium

  * Rebuild with gnat-6 like libxmlada.
    Update patches/use_ada_packaged_libraries.diff accordingly.
    Silent new System.Case_Util style warning in patches/gnat-6-warning.diff.
  * Stop enforcing timestamps in ALI files, only useful for libraries.
  * Enable all hardening flags.
  * Standards-Version: 3.9.8 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Apr 2016 01:29:52 +0200

gprbuild (2015-2) experimental; urgency=medium

  * patch and test linking a library with --as-needed and -z defs.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 29 Jan 2016 23:11:09 +0100

gprbuild (2015-1) experimental; urgency=medium

  * New upstream release, repackaged without GFDL doc, generated autoconf
    stuff and embedded copies of GNAT sources (10 times smaller).
    No more autotools-dev, autoconf, or patch to honor build flags.
  * rules: write compiler command line manually so that gprbuild does not
    build-depend: itself once gnatmake drop support for projects.
  * Build-Depends: take libxmlada split into account.
  * patches: 763727 closed, libraries_after_link_options applied.
    projects_lookup_path.diff: add current Debian path.
  * Drop -doc package, now less than 3% of binary size.
  * watch: use Adacore redirector.
  * Set a deterministic date to the generated source for reproducible builds.
  * gprbuild is not a library, no need to Build-Depend: gnat.
  * Test: handle read-only sources, avoid depending on a reverse build-dep.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 30 Oct 2015 18:29:15 +0100

=== debian/control ===
Source: gprbuild
Section: devel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
# dpkg-dev: /usr/share/dpkg/default.mk
 gnat-6, libgnatprj6-dev, libgnatvsn6-dev
# gnat-v: /usr/share/ada/debian-packaging-v.mk
 ,libxmlada-schema6-dev
 ,libxmlada-dom6-dev
 ,libxmlada-sax6-dev
 ,libxmlada-input-sources6-dev
# libxmlada_unicode is required indirectly
Standards-Version: 3.9.8
Homepage: http://libre.adacore.com/libre/
Vcs-Mtn: www.ada-france.org org.debian.gprbuild
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gprbuild

Package: gprbuild
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gnat (>= 5), g++, gcc, gfortran
# Previous gnat-x.y used x.y instead of x to name tools and libs.
Description: multi-language extensible build tool
 A set of tools for processing GNAT project files:
 gprconfig detects available compilers,
 gprbuild runs them;
 gprslave helps distributing the build work across the network;
 gprinstall copies the objects to their final destination;
 gprclean removes them.
 The default configuration supports Ada, Assembler, C, C++, Fortran,
 and can be extended to support user source processing tools.
 .
 The complete gprbuild user guide cannot be distributed by Debian
 because it is licensed under the GNU Free Documentation License with
 Invariant Sections and Cover Texts. It is published by upstream
 authors at
 http://docs.adacore.com/gprbuild-docs/html/gprbuild_ug.html.

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2016 Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging*.mk

# gprbuild.gpr selects inlining.
ADAFLAGS += -gnatn
# It also selects -E -static binder options, but:
# #666106 affects only kfreebsd-i386, where storing tracebacks in
# exception occurrences causes a segmentation fault.  This prevents
# handling of any exceptions.  gprconfig relies on handling exceptions
# when parsing compilers.xml.
# Author: Ludovic Brenta <lbrenta@debian.org>

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch	\
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@

# If you intend to use autoconf...
# Set target from DEB_HOST_GNU_TYPE instead of config.sub, which adds
# a vendor and does not match "gcc -dumpmachine" at run time.
# The problem is hidden on usual architectures by hand-crafted
# renamings in share/gprconfig/targetset.xml.
# See share/gprconfig/compilers.xml, debian/patches/gprconfig.diff.

# Rewriting recipes is easyer than using upstream build system, and it
# avoids that gprbuilds Build-Depends: gprbuild, now that gnatmake is
# dropping support for projects.
ADAINCLUDE := /usr/share/ada/adainclude
ADALIB     := /usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib

EXECUTABLES := gprbind gprbuild gprclean gprconfig gprinstall gprlib gprslave

.PHONY: override_dh_auto_build
override_dh_auto_build: $(EXECUTABLES)

# Gnatmake knows better than Make if something is up to date.
.PHONY: $(EXECUTABLES)

# Some main units are poorly named.
gprbind gprlib gprslave: MAIN_EXT :=
gprbuild gprclean gprconfig gprinstall: MAIN_EXT := -main

# Each executable may not require each library, but there should be no
# consequence with --as-needed linker flag.
$(EXECUTABLES):
	gnatmake $@$(MAIN_EXT).adb -aIsrc -D obj -o obj/$@ \
          $(BUILDER_OPTIONS) \
          -cargs $(ADAFLAGS) \
          -largs $(LDFLAGS) \
          $(foreach l,schema dom sax input_sources unicode, \
            -margs -aI$(ADAINCLUDE)/xmlada_$(l) -aO$(ADALIB)/xmlada_$(l) \
            -largs -lxmlada_$(l)) \
          $(foreach l,prj vsn, \
            -margs -aI$(ADAINCLUDE)/gnat$(l) -aO/usr/lib/ada/adalib/gnat$(l) \
            -largs -lgnat$(l))

# The only source requiring actual configuration.
SDEFAULT := src/gprconfig-sdefault.ads
$(EXECUTABLES): $(SDEFAULT)
$(SDEFAULT): %: %.in
	sed -e 's/@host@/$(DEB_HOST_GNU_TYPE)/' $< > $@

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -f obj/* $(SDEFAULT)

=== debian/tests/control ===
Tests: ada-policy-project-with-dash-s
Depends: gprbuild, gnat, libgnatvsn6-dev

Tests: link-library-as-needed-z-defs
Depends: gprbuild, gnat

Tests: examples
Depends: gprbuild, gnat, gcc, g++, gfortran, make

## gprbuild 2017

=== Makefile ===
# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build gprbuild:          make all
# Install gprbuild:        make install
# Create gprbuild package: make distall
# Build tool <TOOL>:       make <TOOL>
# Build libgpr:            make libgpr.build
# Install libgpr:          make libgpr.install
# (for libgpr you can add ".type" where type is static, static-pic or shared
#  build a specific version of the lib. by default all supported variants are
#  built).

# Variables which can be set:
#
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : debug production coverage profiling
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#
# Out-of-tree build:
#
#   $ make -f <GPRBUILD_TREE>/Makefile setup
#   $ make -f <GPRBUILD_TREE>/Makefile

HOST    = $(shell gcc -dumpmachine)
TARGET := $(shell gcc -dumpmachine)

prefix	      := $(dir $(shell which gnatls))..
BUILD         = production
PROCESSORS    = 0
BUILD_DIR     =
SOURCE_DIR    := $(shell dirname "$(MAKEFILE_LIST)")

# Load current setup if any
-include makefile.setup

# target options for cross-build
ifeq ($(HOST),$(TARGET))
GTARGET=
INSTALLER=exe/$(LIB_INSTALLER)
else
GTARGET=--target=$(TARGET)
INSTALLER=$(LIB_INSTALLER)
endif

# check for out-of-tree build
ifeq ($(SOURCE_DIR),.)
RBD=
GPRBUILD_GPR=gprbuild.gpr
GPR_GPR=gpr/gpr.gpr
MAKEPREFIX=
else
RBD=--relocate-build-tree
GPRBUILD_GPR=$(SOURCE_DIR)/gprbuild.gpr
GPR_GPR=$(SOURCE_DIR)/gpr/gpr.gpr
MAKEPREFIX=$(SOURCE_DIR)/
endif

ENABLE_SHARED := $(shell gprbuild $(GTARGET) -c -q -p \
	-P$(MAKEPREFIX)config/test_shared 2>/dev/null && echo "yes")

ifeq ($(ENABLE_SHARED), yes)
   LIBGPR_TYPES=static shared static-pic
else
   LIBGPR_TYPES=static
endif

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j${PROCESSORS} -XBUILD=${BUILD} ${GPRBUILD_OPTIONS}
LIB_INSTALLER=gprinstall -p -f --target=$(TARGET) $(RBD) --prefix=${prefix}
CLEANER=gprclean -q $(RBD)

GPRBUILD_BUILDER=$(BUILDER) $(GPRBUILD_GPR) \
	-XLIBRARY_TYPE=static -XXMLADA_BUILD=static
LIBGPR_BUILDER=$(BUILDER) $(GPR_GPR)
LIBGPR_INSTALLER=$(LIB_INSTALLER) $(GPR_GPR) -XBUILD=${BUILD} \
	--install-name=gpr --build-var=LIBRARY_TYPE $(GTARGET)
LIBGPR_UNINSTALLER=$(LIB_INSTALLER) $(GPR_GPR) --install-name=gpr --uninstall

#########
# build #
#########

.PHONY: all distall gprbuild gprconfig gprclean gprinstall gprname gprls

build all:
	$(GPRBUILD_BUILDER)

distall: all install

gprbuild:
	$(GPRBUILD_BUILDER) gprbuild-main.adb

gprinstall:
	$(GPRBUILD_BUILDER) gprinstall-main.adb

gprclean:
	$(GPRBUILD_BUILDER) gprclean-main.adb

gprconfig:
	$(GPRBUILD_BUILDER) gprconfig-main.adb

gprname:
	$(GPRBUILD_BUILDER) gprname-main.adb

gprls:
	$(GPRBUILD_BUILDER) gprls-main.adb

#################################
# Gprbuild installation targets #
#################################

.PHONY: install

install:
	$(INSTALLER) --mode=usage --install-name=gprbuild \
		-XINSTALL_MODE=nointernal $(GPRBUILD_GPR)
	$(INSTALLER) --target=$(TARGET) --mode=usage  --install-name=gprbuild \
		-XINSTALL_MODE=internal $(GPRBUILD_GPR)

complete: all install libgpr.install.static

##########
# Libgpr #
##########

.PHONY: libgpr.build libgpr.build.static libgpr.build.shared libgpr.build.static-pic
.PHONY: libgpr.install libgpr.install.static libgpr.install.shared libgpr.install.static-pic
.PHONY: libgpr.uninstall

libgpr.build: $(foreach t, $(LIBGPR_TYPES), libgpr.build.$(t))

libgpr.build.shared:
	${BUILDER} -XLIBRARY_TYPE=relocatable \
		-XXMLADA_BUILD=relocatable $(GPR_GPR)

libgpr.build.static:
	${BUILDER} -XLIBRARY_TYPE=static \
		-XXMLADA_BUILD=static $(GPR_GPR)

libgpr.build.static-pic:
	${BUILDER} -XLIBRARY_TYPE=static-pic \
		-XXMLADA_BUILD=static-pic $(GPR_GPR)

libgpr.install: libgpr.uninstall $(foreach t, $(LIBGPR_TYPES), libgpr.install.$(t))

libgpr.install.static:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=static \
	   -XXMLADA_BUILD=static \
	   --lib-subdir=lib/gpr/static \
	   --build-name=static

libgpr.install.static-pic:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=static-pic \
	   -XXMLADA_BUILD=static-pic \
	   --lib-subdir=lib/gpr/static-pic \
	   --build-name=static-pic

libgpr.install.shared:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=relocatable \
	   -XXMLADA_BUILD=relocatable \
	   --lib-subdir=lib/gpr/relocatable \
	   --build-name=relocatable

libgpr.uninstall:
	-$(LIBGPR_UNINSTALLER)

libgpr.clean:
	-$(CLEANER) -XLIBRARY_TYPE=relocatable $(GPR_GPR)
	-$(CLEANER) -XLIBRARY_TYPE=static $(GPR_GPR)
	-$(CLEANER) -XLIBRARY_TYPE=static-pic $(GPR_GPR)
	rm -fr gpr/lib gpr/libobj

#########
# setup #
#########

.SILENT: setup
setup:
	echo "prefix=$(prefix)" > makefile.setup
	echo "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	echo "BUILD=$(BUILD)" >> makefile.setup
	echo "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	echo "TARGET=$(TARGET)" >> makefile.setup
	echo "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup

###################
# Cleanup targets #
###################

.PHONY: clean
clean: libgpr.clean
	-$(CLEANER) -r -Pgprbuild -XBUILD=$(BUILD)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=static-pic $(GPR_GPR)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=static $(GPR_GPR)
ifeq ($(ENABLE_SHARED), yes)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=relocatable $(GPR_GPR)
	-$(CLEANER) $(GPR_GPR) -XBUILD=$(BUILD) \
		-XLIBRARY_TYPE=relocatable
endif
	make -C $(MAKEPREFIX)doc clean
	make -C $(MAKEPREFIX)examples clean
	rm -fr obj exe makefile.setup

.PHONY: doc examples

doc:
	make -C $(MAKEPREFIX)doc

examples: force
	make -C $(MAKEPREFIX)examples

force:

=== examples/ada_f77/Makefile ===
all: default.cgpr
	gprbuild -p ft.gpr

default.cgpr:
	gprconfig --batch --config Ada --config Fortran -o $@

clean:
	gprclean -q -r ft.gpr
	$(RM) default.cgpr

run: all
	./fobj/ess

=== examples/first_steps/Makefile ===
all: default.cgpr
	gprbuild -p -Pc_main
	gprbuild -p -Pada_main

default.cgpr:
	gprconfig --batch --config Ada  --config C -o $@

clean: force
	gprclean -Pc_main
	gprclean -Pada_main
	$(RM) default.cgpr

run: all
	./ada_main
	./obj1/c_main
force:

=== examples/libraries/Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
 all: default.cgpr
-	gprbuild main0.gpr
-	gprbuild main1.gpr
-	gprbuild main2.gpr
-	gprbuild main3.gpr
-	gprbuild main4.gpr
+	gprbuild -p main0.gpr
+	gprbuild -p main1.gpr
+	gprbuild -p main2.gpr
+	gprbuild -p main3.gpr
+	gprbuild -p main4.gpr
 
 default.cgpr:
 	gprconfig --batch --config Ada  --config C -o $@

=== examples/matrix/Makefile ===
all: default.cgpr
	gprbuild -p

default.cgpr:
	gprconfig --batch --config Ada  --config C --config Fortran -o $@

clean: force
	gprclean
	$(RM) default.cgpr

run: all
	./obj/main
force:

=== examples/subsystems/Makefile ===
all: default.cgpr
	gprbuild -p -Pc_main
	gprbuild -p -Pada_main

default.cgpr: force
	gprconfig --batch --config Ada --config C -o $@

clean: force
	gprclean -r -Pc_main
	gprclean -r -Pada_main
	$(RM) default.cgpr

run: all
	./ada_main
	./c_main
force:

=== debian/changelog ===
gprbuild (2017-5) unstable; urgency=medium

  * Rebuild with xmlada 17.1.2017-5. -dev version is already new in testing.
  * Increase gprbuild verbosity in run-time test.
  * Standards-Version: 4.1.0.
  * Vcs-Mtn: new monotone URI format.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Sep 2017 14:28:43 +0200

gprbuild (2017-4) unstable; urgency=medium

  * Upload to unstable.
  * Standards-Version: 4.0.1 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 10 Aug 2017 08:24:15 +0200

gprbuild (2017-3) experimental; urgency=medium

  * Do not always recompile Ada sources younger than SOURCE_DATE_EPOCH.
    Closes: #869611. Regression test.
  * Debhelper 10. Drop explicit rules targets confusing dh.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Jul 2017 20:36:24 +0200

gprbuild (2017-2) experimental; urgency=medium

  * libgr-dev Depends: libxmlada*-dev. Adjust project accordingly.
    Let tests/link-with-shared detect such regressions.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 02 Jul 2017 20:33:49 +0200

gprbuild (2017-1) experimental; urgency=medium

  * New upstream release. No ALI/SO bump in experimental.
    Gprbuild now depends on gpr_imports.o and libxmlada* via libgpr.
    Remove applied patches, add typos.diff.
  * Build with gnat-7.
    ALI files use SOURCE_DATE_EPOCH, no need for fake timestamps.
    Exceptions do not require an executable stack, remove lintian override.
  * Install gpr.gpr projectt into new default path /usr/share/gpr.
  * Standards-Version: 4.0.0 and debhelper 10.
  * dpkg-dev now ignores .mtn-ignore by default.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 01 Jul 2017 17:05:45 +0200

gprbuild (2016-3) experimental; urgency=medium

  * do-not-strip-minor-soversion.diff when linking shared libraries.
    A similar patch has been applied to gcc for years.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 26 Aug 2016 15:33:52 +0200

gprbuild (2016-2) experimental; urgency=medium

  * Add aliases for Debian archs so that hardware-vendor-kernel-abi default
    target matches "gcc -dumpmachine" which has no vendor part.
  * Fix a trivial XML syntax error in linker.xml.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 13 Aug 2016 03:32:26 +0200

gprbuild (2016-1) experimental; urgency=medium

  * New upstream release, adding executables: gprls, gprname,
    and a library: GPR, formerly libgnatprj built by gnat from GCC sources.
  * Build without gprbuild itself to avoid bootstrap problems.
    Most changes are copied from XML/Ada which has the same constraints.
  * Link with XML/Ada GPL-2016.
  * Add a runtime test for the library.
  * allow-pie-overriden-for-libs.diff: users may set hardening=+all,
    pie will be overriden for libraries.
  * projects_lookup_path.diff: fix library instead of some tools.
  * add_runtime_source_dirs_to_snames.diff to regenerate gpr-snames.ad[bs].
  * lintian override explaining GCC trampolines, as most Ada libraries.
  * Update watch file to version 4.
  * README.source: link to github, explain choice for SO version.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 11 Aug 2016 01:30:29 +0200

=== debian/control ===
--- 
+++ 
@@ -2,19 +2,43 @@
 Section: devel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
+Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
 # dpkg-dev: /usr/share/dpkg/default.mk
- gnat-6, libgnatprj6-dev, libgnatvsn6-dev
-# gnat-v: /usr/share/ada/debian-packaging-v.mk
- ,libxmlada-schema6-dev
- ,libxmlada-dom6-dev
- ,libxmlada-sax6-dev
- ,libxmlada-input-sources6-dev
+ gnat, gnat-7
+ ,libxmlada-schema7-dev (>= 17.1.2017-5)
+ ,libxmlada-dom7-dev (>= 17.1.2017-5)
+ ,libxmlada-sax7-dev (>= 17.1.2017-5)
+ ,libxmlada-input7-dev (>= 17.1.2017-5)
+# Note: the rules script parses the lines above to extract versions.
 # libxmlada_unicode is required indirectly
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Homepage: http://libre.adacore.com/libre/
-Vcs-Mtn: www.ada-france.org org.debian.gprbuild
+Vcs-Mtn: mtn://www.ada-france.org?org.debian.gprbuild
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gprbuild
+
+Package: libgpr16.1.2016
+Section: libs
+Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
+Description: support for programs processing GNAT projects (runtime)
+ GNAT projects are human-readable text files used to drive tools
+ building or inspecting lots of source files in several programming
+ languages, like those provided by the gprbuild package.
+ .
+ This package contains the runtime shared library.
+
+Package: libgpr1-dev
+Section: libdevel
+Architecture: any
+Depends: ${misc:Depends}, ${ada:Depends}
+Description: support for programs processing GNAT projects (development)
+ GNAT projects are human-readable text files used to drive tools
+ building or inspecting lots of source files in several programming
+ languages, like those provided by the gprbuild package.
+ .
+ This package contains the development tools.
 
 Package: gprbuild
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GPRBuild in Debian.
# Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.


# NOTE:
# In order to prevent a circular build-dependency, the Debian packages
# for XML/Ada and GPRBuild bother to build without project support.
# Please keep the two debian/rules files similar enough to ease
# backport of good ideas.

######################################################################
# *_DEV_PKG, *_LIB_PKG and *_SONAME are read from the control file.
# To debug, replace eval with error.
$(foreach line,$(shell sed -n ' \
  s/^Package:\s*\(lib\([a-z]\+\)\([0-9.]\+\)\)$$/ \
    \2_LIB_PKG:=\1 \
    \2_SONAME:=lib\2.so.\3 \
   /p;\
  s/^Package:\s*\(lib\([a-z]\+\)[0-9.]\+-dev\)$$/ \
    \2_DEV_PKG:=\1 \
   /p;\
  s/^ gnat, gnat-\([0-9.]\+\),\?$$/ \
    GNAT_VERSION:=\1 \
   /p;\
  s/^ ,\(libxmlada-\([a-z]\+\)[0-9.]\+-dev\)\( (.*)\)\?$$/ \
    xmlada_\2_DEV_PKG:=\1 \
   /p;\
  ' debian/control),$(eval $(line)))
DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

# gprbuild.gpr selects inlining.
ADAFLAGS += -gnatn
# It also selects -E -static binder options, but:
# #666106 affects only kfreebsd-i386, where storing tracebacks in
# exception occurrences causes a segmentation fault.  This prevents
# handling of any exceptions.  gprconfig relies on handling exceptions
# when parsing compilers.xml.
# Author: Ludovic Brenta <lbrenta@debian.org>

%:
	dh $@

# Rewrite upstream configure/make build system.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test install clean)

# Rewrite upstream targets without gprbuild or gprclean.
# gnatmake does not support projects anymore, we cannot use xmlada.gpr.

######################################################################
# Regenerate gpr-snames.ad[bs].
obj/shared/$(gpr_SONAME) obj/static/libgpr.a: gpr/src/gpr-snames.ads

obj/xsnames: gpr/xsnames.adb | obj
	gnatmake gpr/xsnames.adb -D obj -o $@ \
	  $(BUILDER_OPTIONS) \
	  -cargs $(ADAFLAGS) \
	  -largs $(LDFLAGS)

gpr/src/gpr-snames.ads: obj/xsnames \
                        gpr/snames.list \
                        gpr/snames_spec_init.txt \
                        gpr/snames_spec_init.txt
	cd gpr; ../$<
	mv gpr/gpr-snames.ad[bs] gpr/src
override_dh_auto_clean::
	rm -f gpr/src/gpr-snames.ad[bs]

######################################################################
ADS_DIR := usr/share/ada/adainclude
GPR_DIR := usr/share/gpr
ALI_DIR := usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib
SO_DIR  := usr/lib/$(DEB_HOST_MULTIARCH)
A_DIR   := usr/lib/$(DEB_HOST_MULTIARCH)

define library_template
# Parameters:
# _SRCDIR: directory containing the sources files
# _deps_int       : used in -aI -aO -l for libs built by this deb source
# _deps_int_direct: subset used for .gpr and ada:Depends
# _deps_ext       : used in -aI -aO -l for libs from packaged Build-Depends
# _deps_ext_direct: subset used for .gpr and ada:Depends
# _deps_gnarl     : used in -l, should be empty or gnarl-BV
# For any dependency d, $(d)_DEV_PKG: deb -dev package for $(d)
# For any internal dependency d, $(d)_SRCDIR as above.

  # Remove pure specifications and separate compilation units.
  $(library)_unit_bodies := $(foreach s, \
    $(wildcard $($(library)_SRCDIR)/*.adb) \
    ,$(if $(shell grep -l '^separate ' $(s)),,$(s)))

  $(library)_c_sources := $(wildcard $($(library)_SRCDIR)/*.c)

  # Build dynamic library.
  override_dh_auto_build-arch: obj/shared/$($(library)_SONAME)
  obj/shared/$($(library)_SONAME): \
        $$(patsubst $($(library)_SRCDIR)/%.c,obj/shared_$(library)_obj/%.o,$$($(library)_c_sources)) \
        | obj/shared obj/shared_$(library)_ali obj/shared_$(library)_obj
    # -fPIC/-shared overrides -fPIE/-pie in ADAFLAGS/LDFLAGS.
	gnatmake -c $$($(library)_unit_bodies) -D obj/shared_$(library)_obj \
          $(BUILDER_OPTIONS) \
	  $(foreach l, $($(library)_deps_int), \
	    -aI$($(l)_SRCDIR) \
	    -aOobj/shared_$(l)_ali) \
	  $(addprefix -aI/$(ADS_DIR)/, $($(library)_deps_ext)) \
	  $(addprefix -aO/$(ALI_DIR)/, $($(library)_deps_ext)) \
          -cargs $(ADAFLAGS) -fPIC
	gcc-$(GNAT_VERSION) $(LDFLAGS) -shared \
	  -o $$@ \
	  -Wl,-soname,$($(library)_SONAME) \
	  obj/shared_$(library)_obj/*.o \
	  -Lobj/shared $(addprefix -l, $($(library)_deps_int) \
	                               $($(library)_deps_ext) \
	                               $($(library)_deps_gnarl) \
	                               gnat-$(GNAT_VERSION))
  # Create development link so that the other libraries may link with it.
	ln -fs $($(library)_SONAME) obj/shared/lib$(library).so
  # Move ALI files to library directory and mark them read-only.
	mv obj/shared_$(library)_obj/*.ali obj/shared_$(library)_ali
	chmod 444 obj/shared_$(library)_ali/*

  # Build static library.
  override_dh_auto_build-arch: obj/static/lib$(library).a
  obj/static/lib$(library).a: \
         $(patsubst $($(library)_SRCDIR)/%.c,obj/static_$(library)_obj/%.o,$($(library)_c_sources)) \
        | obj/static obj/static_$(library)_ali obj/static_$(library)_obj
	gnatmake -c $$($(library)_unit_bodies) -D obj/static_$(library)_obj \
          $(BUILDER_OPTIONS) \
	  $(foreach l, $($(library)_deps_int), \
	    -aI$($(l)_SRCDIR) \
	    -aOobj/static_$(l)_ali) \
	  $(addprefix -aI/$(ADS_DIR)/, $($(library)_deps_ext)) \
	  $(addprefix -aO/$(ALI_DIR)/, $($(library)_deps_ext)) \
	  -cargs $(ADAFLAGS)
	ar rc $$@ obj/static_$(library)_obj/*.o
	ranlib $$@
  # Move ALI files to library directory and mark them read-only.
	mv obj/static_$(library)_obj/*.ali obj/static_$(library)_ali
	chmod 444 obj/static_$(library)_ali/*.ali

  obj/shared_$(library)_obj/%.o: $($(library)_SRCDIR)/%.c | obj/shared_$(library)_obj
	gcc-$(GNAT_VERSION) -c $(CFLAGS) $(CPPFLAGS) $$< -o $$@ -fPIC
  obj/static_$(library)_obj/%.o: $($(library)_SRCDIR)/%.c | obj/static_$(library)_obj
	gcc-$(GNAT_VERSION) -c $(CFLAGS) $(CPPFLAGS) $$< -o $$@

  obj/shared_$(library)_ali obj/shared_$(library)_obj obj/static_$(library)_ali obj/static_$(library)_obj: | obj
	mkdir $$@

  override_dh_install::
  # dynamic library
	dh_install --package=$($(library)_LIB_PKG) \
	  obj/shared/$($(library)_SONAME) \
	  $(SO_DIR)
  # static library
	dh_install --package=$($(library)_DEV_PKG) \
	  obj/static/lib$(library).a \
	  $(A_DIR)
  # development symbolic link
	dh_link --package=$($(library)_DEV_PKG) \
	  $(SO_DIR)/$($(library)_SONAME) \
	  $(SO_DIR)/lib$(library).so
  # ALI files
	dh_install --package=$($(library)_DEV_PKG) \
	  obj/shared_$(library)_ali/*.ali \
	  $(ALI_DIR)/$(library)
  # Sources
	dh_install --package=$($(library)_DEV_PKG) \
	  $($(library)_SRCDIR)/*.ad[bs] $$($(library)_c_sources) \
	  $(ADS_DIR)/$(library)
  # Substitution variables for the control file.
	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
	  $(foreach l, $($(library)_deps_int_direct), $($(l)_DEV_PKG) (=$$$${binary:Version}),) \
	  $(foreach l, $($(library)_deps_ext_direct), $($(l)_DEV_PKG),) \
	  $($(library)_LIB_PKG)' \
	  >> debian/$($(library)_DEV_PKG).substvars

  # Externally built project installed for end users.
  override_dh_auto_build-arch: obj/$(library).gpr
  obj/$(library).gpr: debian/template.gpr | obj
	sed ' \
	  /@IMPORTS@/ { \
	    s//$(foreach l, $($(library)_deps_int_direct) \

=== debian/tests/control ===
Tests: ada-policy-project-with-dash-s link-with-shared
Depends: @, gnat

Tests: link-library-as-needed-z-defs source-date-epoch
Depends: gprbuild, gnat

Tests: examples
Depends: gprbuild, gnat, gcc, g++, gfortran, make

Tests: do-not-strip-minor-soversion
Depends: gprbuild, gnat, binutils

## gprbuild 2018

=== Makefile ===
--- 
+++ 
@@ -32,6 +32,7 @@
 PROCESSORS    = 0
 BUILD_DIR     =
 SOURCE_DIR    := $(shell dirname "$(MAKEFILE_LIST)")
+LIB_DIR       = lib/
 
 # Load current setup if any
 -include makefile.setup
@@ -39,11 +40,13 @@
 # target options for cross-build
 ifeq ($(HOST),$(TARGET))
 GTARGET=
-INSTALLER=exe/$(LIB_INSTALLER)
+INSTALLER=exe/$(BUILD)/$(LIB_INSTALLER)
 else
 GTARGET=--target=$(TARGET)
 INSTALLER=$(LIB_INSTALLER)
 endif
+
+EXEC_INSTALLER=$(INSTALLER) -XBUILD=${BUILD}
 
 # check for out-of-tree build
 ifeq ($(SOURCE_DIR),.)
@@ -78,7 +81,8 @@
 	-XLIBRARY_TYPE=static -XXMLADA_BUILD=static
 LIBGPR_BUILDER=$(BUILDER) $(GPR_GPR)
 LIBGPR_INSTALLER=$(LIB_INSTALLER) $(GPR_GPR) -XBUILD=${BUILD} \
-	--install-name=gpr --build-var=LIBRARY_TYPE $(GTARGET)
+	--install-name=gpr \
+	--build-var=LIBRARY_TYPE --build-var=GPR_BUILD $(GTARGET)
 LIBGPR_UNINSTALLER=$(LIB_INSTALLER) $(GPR_GPR) --install-name=gpr --uninstall
 
 #########
@@ -117,9 +121,9 @@
 .PHONY: install
 
 install:
-	$(INSTALLER) --mode=usage --install-name=gprbuild \
+	$(EXEC_INSTALLER) --mode=usage --install-name=gprbuild \
 		-XINSTALL_MODE=nointernal $(GPRBUILD_GPR)
-	$(INSTALLER) --target=$(TARGET) --mode=usage  --install-name=gprbuild \
+	$(EXEC_INSTALLER) --target=$(TARGET) --mode=usage  --install-name=gprbuild \
 		-XINSTALL_MODE=internal $(GPRBUILD_GPR)
 
 complete: all install libgpr.install.static
@@ -152,21 +156,21 @@
 	$(LIBGPR_INSTALLER) \
 	   -XLIBRARY_TYPE=static \
 	   -XXMLADA_BUILD=static \
-	   --lib-subdir=lib/gpr/static \
+	   --lib-subdir=${LIB_DIR}/gpr/static \
 	   --build-name=static
 
 libgpr.install.static-pic:
 	$(LIBGPR_INSTALLER) \
 	   -XLIBRARY_TYPE=static-pic \
 	   -XXMLADA_BUILD=static-pic \
-	   --lib-subdir=lib/gpr/static-pic \
+	   --lib-subdir=${LIB_DIR}/gpr/static-pic \
 	   --build-name=static-pic
 
 libgpr.install.shared:
 	$(LIBGPR_INSTALLER) \
 	   -XLIBRARY_TYPE=relocatable \
 	   -XXMLADA_BUILD=relocatable \
-	   --lib-subdir=lib/gpr/relocatable \
+	   --lib-subdir=${LIB_DIR}/gpr/relocatable \
 	   --build-name=relocatable
 
 libgpr.uninstall:

=== debian/changelog ===
gprbuild (2018-8) unstable; urgency=medium

  * A correct transition is being prepared in experimental.
    For now, let -dev Conflict: libgrpc-dev and revert 2018-7.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 12 Dec 2019 19:24:55 +0100

gprbuild (2018-7) unstable; urgency=medium

  * Rename libgpr.(a|so) to libgnatprj because the grpc source owns them.
    Closes: #945197.  Previous libgnatprj*-dev own libgnatprj.(a|so), but
    Depend: distinct gnat versions so coinstallation is already prevented.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 30 Nov 2019 11:57:50 +0100

gprbuild (2018-6) unstable; urgency=medium

  * Fix test of static archives by removing an undeclared dependency.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 11 Nov 2018 14:15:29 +0100

gprbuild (2018-5) unstable; urgency=medium

  * Fix rdeps on ia64 by restoring all Debian architectures,
    even the ones missing a gcc-8 binary package for the moment.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 07 Nov 2018 22:06:48 +0100

gprbuild (2018-4) unstable; urgency=medium

  * Fix FTBFS on i386-* architectures caused by changes for static
    archives and add-targets-for-gnat-s_osconf.diff.
    - use i686 instead of i386 in the canonical name as in regexs.
    - move Hurd regex after less selective ones like linux or freebsd.
    - only add Debian architectures with a gcc-8 package.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 06 Nov 2018 22:53:00 +0100

gprbuild (2018-3) unstable; urgency=medium

  * Fix and test build of static archives:
    gprconfig was finding no archiver on many architectures.
  * Add warnings and checks to build flags.
  * Standards-Version: 4.2.1. Rules-Requires-Root: no.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 01 Nov 2018 10:15:58 +0100

gprbuild (2018-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:49 +0200

gprbuild (2018-1) experimental; urgency=medium

  * New upstream release. No package renaming in experimental.
  * Update targetsets syntax in add-targets-for-gnat-s_osconf.diff.
    Generate this patch from latest syntax and architecture list.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 09 Jun 2018 23:03:04 +0200

gprbuild (2017-7) experimental; urgency=medium

  * Rebuild with gnat-8, libxmlada-*8-dev.
    Rename shared library and -dev package per Debian Ada policy.
  * Remove watch file, explain why in README.source.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 07 May 2018 20:21:57 +0200

gprbuild (2017-6) unstable; urgency=medium

  * Delete whitespaces in this changelog.
  * Debhelper 11.
  * Drop obsolete version restriction for dpkg-dev.
  * Fix silly formatting of Build-Depends.
  * Standards-Version: 4.1.4.
  * Update upstream homepage URL.
  * Drop overrides for lintian pedantic messages.
  * Try gnat-8: set version from -dumpversion (8) instead of -v (8.1.0).

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 03 May 2018 15:12:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,21 @@
 Section: devel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
-# dpkg-dev: /usr/share/dpkg/default.mk
- gnat, gnat-7
- ,libxmlada-schema7-dev (>= 17.1.2017-5)
- ,libxmlada-dom7-dev (>= 17.1.2017-5)
- ,libxmlada-sax7-dev (>= 17.1.2017-5)
- ,libxmlada-input7-dev (>= 17.1.2017-5)
+Build-Depends: debhelper (>= 11),
+ gnat, gnat-8,
+ libxmlada-schema8-dev,
+ libxmlada-dom8-dev,
+ libxmlada-sax8-dev,
+ libxmlada-input8-dev,
 # Note: the rules script parses the lines above to extract versions.
 # libxmlada_unicode is required indirectly
-Standards-Version: 4.1.0
-Homepage: http://libre.adacore.com/libre/
+Standards-Version: 4.2.1
+Rules-Requires-Root: no
+Homepage: https://www.adacore.com/community
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.gprbuild
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gprbuild
 
-Package: libgpr16.1.2016
+Package: libgpr18
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -29,10 +29,12 @@
  .
  This package contains the runtime shared library.
 
-Package: libgpr1-dev
+Package: libgpr2-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
+Conflicts: libgrpc-dev
+# Until gprbuild/2019 reaches unstable, see #945197.
 Description: support for programs processing GNAT projects (development)
  GNAT projects are human-readable text files used to drive tools
  building or inspecting lots of source files in several programming

## gprbuild 2019

=== Makefile ===
--- 
+++ 
@@ -225,3 +225,7 @@
 	make -C $(MAKEPREFIX)examples
 
 force:
+
+# Let gprbuild handle parallelization. In general, we don't support parallel
+# runs in this Makefile, as concurrent gprinstall processes may crash.
+.NOTPARALLEL:

=== examples/ada_cpp/Makefile ===
all: default.cgpr
	gprbuild -p animals.gpr
	gprbuild -p except.gpr

default.cgpr:
	gprconfig --batch --config Ada  --config C++ -o $@

clean: force
	gprclean -r -Panimals
	gprclean -r -Pexcept
	$(RM) default.cgpr

run: all
	./ada_main
	./cpp_main
	./main
force:

=== debian/changelog ===
gprbuild (2019-3) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 24 Feb 2020 22:03:24 +0100

gprbuild (2019-2) experimental; urgency=medium

  * Rename libgpr{19,3-dev} to libgnatprj{7,7-dev}. This completes the fix
    for #945197 by 2018-7, but requires changes in reverse dependencies.
  * Standards-Version: 4.4.1.
  * --as-needed is the default with gcc-9.
  * Include only needed dpkg makefile snippets.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 03 Dec 2019 18:13:22 +0100

gprbuild (2019-1) experimental; urgency=medium

  * New upstream release, built with gnat-9 and updated dependencies.
    Migration in experimental, renaming lib and -dev packages.
  * Move Version Control System to salsa.
  * Debhelper 12.
  * Standards-Version 4.4.0.
  * gprconfig.patch: more comments, fewer changes.
    Stop enforcing the Ada linker for projects mixing languages.
    Stop proposing gnatgcc as a distinct compiler.
  * Stop looking for projects in obsolete /usr/share/gpr.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 11 Jul 2019 13:08:16 +0200

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,22 @@
 Section: devel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
- libxmlada-schema8-dev,
- libxmlada-dom8-dev,
- libxmlada-sax8-dev,
- libxmlada-input8-dev,
+Build-Depends:
+ debhelper-compat (= 12),
+ gnat, gnat-9,
+ libxmlada-schema9-dev,
+ libxmlada-dom9-dev,
+ libxmlada-sax9-dev,
+ libxmlada-input9-dev,
 # Note: the rules script parses the lines above to extract versions.
 # libxmlada_unicode is required indirectly
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://www.adacore.com/community
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.gprbuild
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gprbuild
+Vcs-Browser: https://salsa.debian.org/debian/gprbuild
+Vcs-Git: https://salsa.debian.org/debian/gprbuild.git
 
-Package: libgpr18
+Package: libgnatprj7
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -29,12 +30,10 @@
  .
  This package contains the runtime shared library.
 
-Package: libgpr2-dev
+Package: libgnatprj7-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
-Conflicts: libgrpc-dev
-# Until gprbuild/2019 reaches unstable, see #945197.
 Description: support for programs processing GNAT projects (development)
  GNAT projects are human-readable text files used to drive tools
  building or inspecting lots of source files in several programming

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # Build script for GPRBuild in Debian.
 # Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
-# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2019 Nicolas Boulenguez <nicolas@debian.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,7 +16,6 @@
 # On Debian systems, the full text of the GPL is in the file
 # /usr/share/common-licenses/GPL-3.
 
-
 # NOTE:
 # In order to prevent a circular build-dependency, the Debian packages
 # for XML/Ada and GPRBuild bother to build without project support.
@@ -24,29 +23,33 @@
 # backport of good ideas.
 
 ######################################################################
-# *_DEV_PKG, *_LIB_PKG and *_SONAME are read from the control file.
+# Read some variables from the Debian control file.
 # To debug, replace eval with error.
 $(foreach line,$(shell sed -n ' \
-  s/^Package:\s*\(lib\([a-z]\+\)\([0-9.]\+\)\)$$/ \
-    \2_LIB_PKG:=\1 \
-    \2_SONAME:=lib\2.so.\3 \
+  s/^Package: \(libgnatprj\([0-9.]\+\)\)$$/ \
+    gnatprj_LIB_PKG:=\1 \
+    gnatprj_SONAME:=libgnatprj.so.\2 \
    /p;\
-  s/^Package:\s*\(lib\([a-z]\+\)[0-9.]\+-dev\)$$/ \
-    \2_DEV_PKG:=\1 \
+  s/^Package:\s*\(libgnatprj[0-9.]\+-dev\)$$/ \
+    gnatprj_DEV_PKG:=\1 \
    /p;\
   s/^ gnat, gnat-\([0-9.]\+\),\?$$/ \
     GNAT_VERSION:=\1 \
    /p;\
-  s/^ ,\(libxmlada-\([a-z]\+\)[0-9.]\+-dev\)\( (.*)\)\?$$/ \
+  s/^ \(libxmlada-\([a-z]\+\)[0-9.]\+-dev\)\( (.*)\)\?,\?$$/ \
     xmlada_\2_DEV_PKG:=\1 \
    /p;\
   ' debian/control),$(eval $(line)))
+
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
-include /usr/share/dpkg/default.mk
+DEB_ADAFLAGS_MAINT_APPEND := -gnatwa -Wall -gnatn
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
+  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
+include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
 
 # gprbuild.gpr selects inlining.
-ADAFLAGS += -gnatn
 # It also selects -E -static binder options, but:
 # #666106 affects only kfreebsd-i386, where storing tracebacks in
 # exception occurrences causes a segmentation fault.  This prevents
@@ -54,6 +57,7 @@
 # when parsing compilers.xml.
 # Author: Ludovic Brenta <lbrenta@debian.org>
 
+######################################################################
 %:
 	dh $@
 
@@ -66,7 +70,8 @@
 
 ######################################################################
 # Regenerate gpr-snames.ad[bs].
-obj/shared/$(gpr_SONAME) obj/static/libgpr.a: gpr/src/gpr-snames.ads
+obj/shared/$(gnatprj_SONAME) \
+obj/static/libgnatprj.a                   : gpr/src/gpr-snames.ads
 
 obj/xsnames: gpr/xsnames.adb | obj
 	gnatmake gpr/xsnames.adb -D obj -o $@ \
@@ -93,6 +98,7 @@
 define library_template
 # Parameters:
 # _SRCDIR: directory containing the sources files
+# _SONAME : shared object name (libNAME.so.VERSION)
 # _deps_int       : used in -aI -aO -l for libs built by this deb source
 # _deps_int_direct: subset used for .gpr and ada:Depends
 # _deps_ext       : used in -aI -aO -l for libs from packaged Build-Depends
@@ -188,12 +194,3 @@
 	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
 	  $(foreach l, $($(library)_deps_int_direct), $($(l)_DEV_PKG) (=$$$${binary:Version}),) \
 	  $(foreach l, $($(library)_deps_ext_direct), $($(l)_DEV_PKG),) \
-	  $($(library)_LIB_PKG)' \
-	  >> debian/$($(library)_DEV_PKG).substvars
-
-  # Externally built project installed for end users.
-  override_dh_auto_build-arch: obj/$(library).gpr
-  obj/$(library).gpr: debian/template.gpr | obj
-	sed ' \
-	  /@IMPORTS@/ { \
-	    s//$(foreach l, $($(library)_deps_int_direct) \

=== debian/tests/control ===
--- 
+++ 
@@ -1,3 +1,6 @@
+Tests: archive-builder
+Depends: gprbuild, gcc
+
 Tests: ada-policy-project-with-dash-s link-with-shared
 Depends: @, gnat
